import java.awt.Graphics2D
import java.awt.image.BufferedImage
import java.awt.image.RescaleOp

// val MAX_SIZE: Int = 256

// TODO: Enforce MAX_SIZE
// TODO: Cookie cutter out a roundrect

class ButtonArt(
    val base: BufferedImage,
    val highlighted: BufferedImage,
    val pressed: BufferedImage
) {
    companion object {
        fun fromArbitraryImage(base: BufferedImage): ButtonArt {
            return ButtonArt(
                base,
                base.toHighlighted(),
                base.toPressed(),
            )
        }
    }
}

private fun BufferedImage.toHighlighted(): BufferedImage {
    val highlighted = BufferedImage(width, height, BufferedImage.TYPE_INT_ARGB)
    val g = highlighted.graphics as Graphics2D
    val op = RescaleOp(0.75f, 128f, null)
    g.drawImage(this, 0, 0, width, height, 0, 0, width, height, null)
    op.filter(highlighted, highlighted)
    return highlighted
}

private fun BufferedImage.toPressed(): BufferedImage {
    val pressed = BufferedImage(width, height, BufferedImage.TYPE_INT_ARGB)
    val g = pressed.graphics as Graphics2D
    val op = RescaleOp(2.0f, 0.0f, null)
    g.drawImage(this, 0, 0, width, height, 0, 0, width, height, null)
    op.filter(pressed, pressed)
    return pressed
}
