import java.awt.event.WindowAdapter
import java.awt.event.WindowEvent
import java.awt.image.BufferedImage
import javax.swing.JFrame
import javax.swing.Timer
import kotlin.system.exitProcess
import kotlinx.datetime.*
import kotlinx.datetime.TimeZone
import java.awt.*
import java.io.ByteArrayInputStream
import java.util.*
import javax.imageio.ImageIO
import javax.swing.JButton
import javax.swing.JLabel
import javax.swing.JPanel

fun main(args: Array<String>) {
    val app = App()

    app.start()
}

class App {
    private var model = AppModel()

    private var running: Boolean = false
    private val worker = createWorker()
    private val appView = createAppView()

    fun start() {
        running = true
        worker.start()

        val demoIcon = getImage("/demoIcon.png")!!

        for (i in 0..2) {
            model.updateTask(
                TaskRecord(
                    uuid = UUID.randomUUID(),
                    icon = IconRecord(demoIcon),
                    task = "FIX THE DOG",
                    link = null,
                    createdAt = Clock.System.now().toLocalDateTime(TimeZone.currentSystemDefault()),
                    blinkAt = Clock.System.now().toLocalDateTime(TimeZone.currentSystemDefault())
                )
            )
        }
    }

    private fun createWorker(): Timer {
        return Timer(33) { onFrame() }
    }

    private fun createAppView(): AppView {
        val av = AppView(model)
        av.addWindowListener(object: WindowAdapter() {
            override fun windowClosing(e: WindowEvent?) {
                running = false
            }
        })

        return av
    }

    private fun onFrame() {
        if (!running) { exitProcess(0) }

        if (running) appView.isVisible = true
        appView.touch()
    }
}
